--------------------------------------------------------------------------------
--<<                                Destroy                                 >>--   
--------------------------------------------------------------------------------  

local autodestroy_queue = {}

local echo = KarniCrap_Echo


-- Get number of free bag slots
function KarniCrap_GetFreeSlots()
	local totalFreeSlots = 0
	for bag = 0,4 
		do freeSlots, bagType = GetContainerNumFreeSlots(bag)
		if bagType then 
			totalFreeSlots = totalFreeSlots + freeSlots
		end
	end
	return totalFreeSlots
end


function KarniCrap_CheckDestroyConditions()
	if KarniCrapConfig.Destroy == false then
		return nil 
	else
		-- more free slots than autodestroyslotsnum, skip autodestroy looting
		if KarniCrapConfig.DestroySlots == true and KarniCrap_GetFreeSlots() > KarniCrapConfig.DestroySlotsNum then 
			return nil 
		else
			if KarniCrapConfig.DestroyGroup == true and KarniCrapConfig.NumberInParty > 0 then return nil end
			if KarniCrapConfig.DestroyRaid == true and KarniCrapConfig.NumberInRaid > 0 then return nil end
		end
	end
	return 1
end 

function KarniCrap_AddToDestroyQueue(id, link, quantity, details)
	local autodestroy_iteminfo = {}

	if debug then echo("Adding "..link.." to destroy_queue") end
	
	autodestroy_iteminfo["id"] = id
	autodestroy_iteminfo["link"] = link
	autodestroy_iteminfo["quantity"] = quantity
	autodestroy_iteminfo["details"] = details

	table.insert(autodestroy_queue, autodestroy_iteminfo)

	return 1
end



function KarniCrap_DestroyQueue()
	if #autodestroy_queue > 0 then
		for k, v in pairs(autodestroy_queue) do
			local bag, slot, count = KarniCrap_FindBagSlot(v.id, v.quantity )
			
			if bag and slot then 
				KarniCrap_DestroyItem(v.link, bag, slot, v.quantity)
			end
			autodestroy_queue[k] = nil

		end
	end
	return 1
end



function KarniCrap_DestroyItem(itemlink, bag, slot, quantity)
	local _, stackcount, locked = GetContainerItemInfo( bag, slot )
	if quantity == stackcount then
		PickupContainerItem( bag, slot )
		if CursorHasItem() then
			DeleteCursorItem()
			if KarniCrapConfig.Echo == true then 
				echo("Destroying "..itemlink.." x"..quantity.." because it's crap!")
			end
		else
			return nil
		end
	elseif quantity < stackcount then
		SplitContainerItem( bag, slot, quantity )
		if CursorHasItem() then
			DeleteCursorItem()
			if KarniCrapConfig.Echo == true then 
				echo("Destroying "..itemlink.." x"..quantity.." because it's crap!")
			end
		else
			return nil
		end
	end		
	return 1
end



function KarniCrapConfig_SetDestroySlotsNum()
	local slots = KarniCrap_EBDestroySlotsNum:GetNumber()
	
	if not slots or slots < 1 then slots = 1 end
	
	KarniCrap_EBDestroySlotsNum:SetNumber(slots)
	KarniCrapConfig.DestroySlotsNum = slots
	return 1
end





